/*
 ==============================================================================

 This is an automatically generated file created by the Jucer!

 Creation date:  22 Sep 2011 2:41:46pm

 Be careful when adding custom code to these files, as only the code within
 the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
 and re-saved.

 Jucer version: 1.12

 ------------------------------------------------------------------------------

 The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
 Copyright 2004-6 by Raw Material Software ltd.

 ==============================================================================
 */

//[Headers] You can add your own extra header files here...
#include <winsock2.h>
#include <Ws2tcpip.h>
#include "comunications.h"
//[/Headers]

#include "udpCom.h"

//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
udpCom::udpCom() {

	//[UserPreSize]
	//[/UserPreSize]

	//setSize (10, 10);

	//[Constructor] You can add your own custom stuff here..

	strcpy(r_config.localIP    , "127.0.0.1");
	strcpy(r_config.remoteIP   , "127.0.0.1");
	strcpy(r_config.multicastIP, "...");
	r_config.localPort  = 8000;
	r_config.remotePort = 8000;

	r_UDP_Enabled = false;
	r_confHasChanged = true;
	r_allowMulticast = false;
	r_invalidPort = false,
	comunications::getRef()->appendInterface(this, "UDP");

	//[/Constructor]
}

udpCom::~udpCom() {
	//[Destructor_pre]. You can add your own custom destruction code here..
	//[/Destructor_pre]


	//[Destructor]. You can add your own custom destruction code here..

	// Cleanup
	WSACleanup();

	//[/Destructor]
}

//==============================================================================
//void udpCom::paint (Graphics& g)
//{
//    //[UserPrePaint] Add your own custom painting code here..
//    //[/UserPrePaint]
//
//    g.fillAll (Colours::white);
//
//    //[UserPaint] Add your own custom painting code here..
//    //[/UserPaint]
//}
//
//void udpCom::resized()
//{
//    //[UserResized] Add your own custom resize handling here..
//    //[/UserResized]
//}


//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
comStatus udpCom::initialize() {

	WSADATA WSAData;

	// Initialize winsock dll and add UDP to know com. interfaces
	if (WSAStartup(MAKEWORD(1, 0), &WSAData) && r_UDP_Enabled == false){
		// All it's OK

	}

	// Get descriptor for a new socket.
	if (r_UDP_Enabled==true){
		closesocket(r_UdpSocket);
	}

	r_UdpSocket = socket(PF_INET, SOCK_DGRAM, 0);
	if (r_UdpSocket < 0){
		perror("Adquiriendo descriptor para socket.");
		return connectionFail;
	}

	// Enable socket reuse.
	int on = 1;
	if (setsockopt(r_UdpSocket, SOL_SOCKET, SO_REUSEADDR, (char*)&on, sizeof(on))<0){
		// CAN'T ENABLE THIS OPTION.
		perror("Habilitando opcion SO_REUSEADDR.");
		return connectionFail;
	}

	r_UDP_Enabled = true;

	return connectionOk;
}

int udpCom::sendBuffer(char* buffer, int length) {

	SOCKADDR_IN confSocketTX;
	unsigned int bytesToSend = length;
	unsigned int nBytes = 0;

	if (r_UDP_Enabled == false) {
		return -1;
	}

	//PREPARAMOS LA ESTRUCTURA CON LOS DATOS DEL DESTINO
	confSocketTX.sin_family = AF_INET;
	confSocketTX.sin_addr.s_addr = inet_addr(r_config.remoteIP);
	confSocketTX.sin_port = htons(r_config.remotePort);
	memset(&(confSocketTX.sin_zero), '\0', 8);

	//ENVIAMOS TODOS LOS DATOS DEL BUFFER POR LAN.
	do {
		nBytes = sendto(
				r_UdpSocket,
				buffer + (length - bytesToSend),
				bytesToSend,
				0,
				(struct sockaddr *) &confSocketTX,
				sizeof(confSocketTX));

		if (nBytes >= 0) {
			bytesToSend -= nBytes;
		} else {
			perror("Enviando un buffer por el socket.");
			return -1;
		}

	} while (bytesToSend > 0);

	return 0;
}

int udpCom::receiveBuffer(char* rxBuffer) {

	int nBytes=0;
	SOCKADDR_IN confSocketRX;
	struct timeval tv;
	fd_set readfds;
	int fromLen= sizeof(struct sockaddr);

	if (r_UDP_Enabled==false || r_invalidPort==true){
		return -1;
	}

	if (r_confHasChanged){
		initialize();

		confSocketRX.sin_family = AF_INET;
		confSocketRX.sin_addr.s_addr = inet_addr(r_config.localIP);
		confSocketRX.sin_port = htons(r_config.localPort);
		memset(&(confSocketRX.sin_zero), '\0', 8);

		//////////////////////////////////////////////////////////////////////////////////////////////
		if (strcmp(r_config.multicastIP, "...")){
			//SUBCRIBIMOS EL SOCKET AL GRUPO MULTICAST ESPECIFICADO.
			struct ip_mreq {
				struct in_addr imr_multiaddr; /* Direccion multicast IP del grupo */
				struct in_addr imr_interface; /* Direccion IP local del interfaz */
			}mreq;

			mreq.imr_interface.s_addr = inet_addr(r_config.localIP);
			mreq.imr_multiaddr.s_addr = inet_addr(r_config.multicastIP);
			if( setsockopt(r_UdpSocket, IPPROTO_IP, IP_ADD_MEMBERSHIP,(const char*)&mreq, sizeof(mreq))<0 ){
				printf( "-------------------------------------\n");
				printf("> ERROR SUBCRIBIENDO MULTICAST.\n");
				printf("> IP  : %s\n", r_config.localIP);
				printf("> MC  : %s\n",r_config.multicastIP);
				printf("> PORT: %d\n",r_config.localPort);
				printf( "-------------------------------------\n");
				fflush(stdout);
				//return connectionFail;
			}

			//DESHABILITAMOS IP_MULTICAST_LOOP PARA EVITAR QUE RECIBAMOS LO MISMO QUE HEMOS ENVIADO.
			if (r_config.allowLoop==true){
				u_char loop;
				if (setsockopt(r_UdpSocket, IPPROTO_IP, IP_MULTICAST_LOOP, (const char*)&loop, sizeof(loop))<0){
					printf("ERROR. No se puede deshabilitar IP_MULTICAST_LOOP.");
					fflush(stdout);
					//return connectionFail;
				}
			}

			//CONFIGURAMOS TTL MULTICAST PARA QUE LOS PAQUETES PUEDAN REALIZAR MAS DE UN SALTO EN LA RED.
			if (r_config.TTL>0){
				char ttl= r_config.TTL;
				if (setsockopt(r_UdpSocket, IPPROTO_IP, IP_MULTICAST_TTL, &ttl, sizeof(ttl))<0){
					printf("No se puede configurar TTL.\n");
					fflush(stdout);
					//return connectionFail;
				}
			}

			//allowMulticast = true;
			//confSocketRX.sin_addr.s_addr = inet_addr(r_config.multicastIP);
			printf("MULTICAST CONFIGURADO CORRECTAMENTE!");
			fflush(stdout);
		}
		//////////////////////////////////////////////////////////////////////////////////////////////

		//ASOCIAMOS CONFIGURACION CON SOCKET LOCAL
		if (bind(r_UdpSocket, (LPSOCKADDR) &confSocketRX, sizeof(struct sockaddr)) < 0) {
			//BIND ERROR.
			perror("Haciendo bind() al socket.");
			AlertWindow::showMessageBox(AlertWindow::WarningIcon, "Invalid Port!","Can't read from current port.\nTry to configure other valid port.");
			r_invalidPort=true;
			return -1;
		}

		r_invalidPort=false;
		r_confHasChanged=false;
	}

	tv.tv_sec  = 1; //1s de timeout
	tv.tv_usec = 0;
	FD_ZERO(&readfds);
	FD_SET(r_UdpSocket, &readfds);
	select(r_UdpSocket+1, &readfds, NULL, NULL, &tv);

	if (FD_ISSET(r_UdpSocket, &readfds)){
		nBytes = recvfrom(r_UdpSocket, rxBuffer, _MAX_INCOMMING_BUFFER_SIZE_, 0, (SOCKADDR *)&confSocketRX, &fromLen);
	}
	else{
		// Timeout!
		return 0;
	}

	if (nBytes < 0) {
		perror("recvfrom error.");
	}

	return nBytes;
}

void udpCom::configure(void* configuration){
	memcpy((void*)&r_config, configuration, sizeof(udpConfig));
	printf("UDP CONFIG\n");
	printf("LOCAL:     %s:%d\n",r_config.localIP,r_config.localPort);
	printf("REMOTO:    %s:%d\n",r_config.remoteIP,r_config.remotePort);
	printf("MULTICAST: %s:%d\n",r_config.multicastIP,r_config.localPort);
	fflush(stdout);

	r_confHasChanged = true;
	r_invalidPort = false;
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

 This is where the Jucer puts all of its metadata, so don't change anything in here!

 BEGIN_JUCER_METADATA

 <JUCER_COMPONENT documentType="Component" className="udpCom" componentName=""
 parentClasses="public Component, public generiCom" constructorParams=""
 variableInitialisers="" snapPixels="8" snapActive="1" snapShown="1"
 overlayOpacity="0.330000013" fixedSize="1" initialWidth="10"
 initialHeight="10">
 <BACKGROUND backgroundColour="ffffffff"/>
 </JUCER_COMPONENT>

 END_JUCER_METADATA
 */
#endif
