/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  9 Aug 2011 9:04:44am

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...

//[/Headers]

#include "hexEditor.h"
#include "MsgEditor.h"

//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
hexEditor::hexEditor ()
    : startButton (0),
      previousButton (0),
      nextButton (0),
      endButton (0)
{
    addAndMakeVisible (startButton = new TextButton (T("start")));
    startButton->setButtonText (T("START"));
    startButton->setConnectedEdges (Button::ConnectedOnRight);
    startButton->addListener (this);

    addAndMakeVisible (previousButton = new TextButton (T("previous")));
    previousButton->setButtonText (T("PREVIOUS"));
    previousButton->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight);
    previousButton->addListener (this);

    addAndMakeVisible (nextButton = new TextButton (T("next")));
    nextButton->setButtonText (T("NEXT"));
    nextButton->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight);
    nextButton->addListener (this);

    addAndMakeVisible (endButton = new TextButton (T("end")));
    endButton->setButtonText (T("END"));
    endButton->setConnectedEdges (Button::ConnectedOnLeft);
    endButton->addListener (this);


    //[UserPreSize]
    //[/UserPreSize]

    setSize (300, 240);

    //[Constructor] You can add your own custom stuff here..
    filas = 5;
    columnas = 10;
    startByte = 0;

    for (int i=0;i<filas*columnas; i++){
    	addAndMakeVisible (dataEditors[i] = new byteEditor());//TextEditor());
    	dataEditors[i]->setMultiLine(false,true);
    }

    unsigned int index=0;
    for (int i=0;i<filas;i++){
		addAndMakeVisible (posLabel[i] = new Label());
		posLabel[i]->setText(String::toHexString((short)index).paddedLeft('0',4).toUpperCase(),false);
		posLabel[i]->setBounds(0,i*26,44,24);
		posLabel[i]->setColour(Label::backgroundColourId, Colour::fromRGB(0x66,0x66,0x66));
		posLabel[i]->setColour(Label::textColourId, Colour::fromRGB(0xFF,0xFF,0xFF));
		for (int j=0;j<columnas;j++){
			dataEditors[index]->setInputRestrictions(2,T("0123456789ABCDEF"));
			dataEditors[index]->setBounds(j*26+44, i*26, 25, 25);
			index++;
		}
	}

	dataLenght = 0;// _DATA_BUFFER_LENGTH_;
	refreshTable();

    //[/Constructor]
}

hexEditor::~hexEditor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    deleteAndZero (startButton);
    deleteAndZero (previousButton);
    deleteAndZero (nextButton);
    deleteAndZero (endButton);

    //[Destructor]. You can add your own custom destruction code here..
	for (unsigned int i=0; i< 30;i++){
		deleteAndZero (dataEditors[i]);
	}
    //[/Destructor]
}

//==============================================================================
void hexEditor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    //[UserPaint] Add your own custom painting code here..
    updateDataBuffer();

    //[/UserPaint]
}

void hexEditor::resized()
{
    startButton->setBounds (12, 134, 64, 24);
    previousButton->setBounds (76, 134, 72, 24);
    nextButton->setBounds (148, 134, 72, 24);
    endButton->setBounds (220, 134, 66, 24);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void hexEditor::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == startButton)
    {
        //[UserButtonCode_startButton] -- add your button handler code here..
    	startByte=0;

    	startButton->setEnabled(false);
    	previousButton->setEnabled(false);
    	nextButton->setEnabled(true);
    	endButton->setEnabled(true);

        //[/UserButtonCode_startButton]
    }
    else if (buttonThatWasClicked == previousButton)
    {
        //[UserButtonCode_previousButton] -- add your button handler code here..
    	if (startByte-(filas*columnas)>0){
    		startByte -= (filas*columnas);
    	}
    	else{
    		startByte=0;
    		startButton->setEnabled(false);
    		previousButton->setEnabled(false);
    	}

    	nextButton->setEnabled(true);
    	endButton->setEnabled(true);
        //[/UserButtonCode_previousButton]
    }
    else if (buttonThatWasClicked == nextButton)
    {
        //[UserButtonCode_nextButton] -- add your button handler code here..
    	if (startByte+(filas*columnas)<dataLenght){
    		startByte += (filas*columnas);
    	}

    	if( (dataLenght-startByte) < (filas*columnas)+1){
    		nextButton->setEnabled(false);
    		endButton->setEnabled(false);
    	}

    	startButton->setEnabled(true);
    	previousButton->setEnabled(true);

        //[/UserButtonCode_nextButton]
    }
    else if (buttonThatWasClicked == endButton)
    {
        //[UserButtonCode_endButton] -- add your button handler code here..
    	startByte = dataLenght - (dataLenght%(filas*columnas));

    	//Disable End Button
    	startButton->setEnabled(true);
    	previousButton->setEnabled(true);
    	nextButton->setEnabled(false);
    	endButton->setEnabled(false);
    	//[/UserButtonCode_endButton]
    }

    //[UserbuttonClicked_Post]
    refreshTable();
    //[/UserbuttonClicked_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
void hexEditor::refreshTable(){
	unsigned int index= startByte;

	for (int i=0;i<filas;i++){

		posLabel[i]->setText(String::toHexString((short)index).paddedLeft('0',4).toUpperCase(),false);
		for (int j=0;j<columnas;j++){
			if (index<dataLenght){
				dataEditors[index-startByte]->setText(String::toHexString((short)dataBuffer[index]).paddedLeft('0',2).toUpperCase(),false);
				dataEditors[index-startByte]->setVisible(true);

			}else{
				dataEditors[index-startByte]->setText("",false);
				dataEditors[index-startByte]->setVisible(false);
			}
			index++;
		}
	}

}

void hexEditor::updateDataBuffer(){

	for (int i=0;i<filas*columnas;i++){
		if ((startByte+i)<dataLenght){
			dataBuffer[startByte+i] = dataEditors[i]->getText().getHexValue32();
		}
	}
}

int hexEditor::getDataBuffer(char* dataBuffer){
	updateDataBuffer();
	memcpy (dataBuffer,this->dataBuffer,dataLenght);
	return dataLenght;
}

int hexEditor::getDataLength(){

	return dataLenght;
}

void hexEditor::setDataBuffer(char* dataBuffer, unsigned int length, bool backToTop){
	if (length>=0 && length<=_HEX_BUFFER_LENGTH_){
		memcpy(this->dataBuffer,dataBuffer,length);

		if (backToTop){
			startByte=0;
		}

		dataLenght=length;

		if (startByte>=dataLenght) {
			if ((dataLenght-(filas*columnas))>=0){
				startByte = dataLenght-(filas*columnas);
				if (startByte<0){
					startByte=0;
				}
			}
			else{
				startByte=0;
			}
    	}

		refreshTable();

		if (dataLenght<(filas*columnas)+1){
			startByte=0;
			startButton->setEnabled(false);
			previousButton->setEnabled(false);
			nextButton->setEnabled(false);
			endButton->setEnabled(false);
		}else{
			if ((dataLenght-startByte)>(filas*columnas)){
				nextButton->setEnabled(true);
				endButton->setEnabled(true);
			}
			else{
				nextButton->setEnabled(false);
				endButton->setEnabled(false);
			}

			if (startByte>(filas*columnas)){
				startButton->setEnabled(true);
				previousButton->setEnabled(true);
			}

		}
	}
	else{
		AlertWindow::showMessageBox(
			AlertWindow::WarningIcon,
			"CAN'T UPDATE HEXEDITOR CONTENT!",
			"Incomming buffer is to big [" + String(length) +" bytes > " + String(_HEX_BUFFER_LENGTH_) + " bytes]"
		);
	}
}

void hexEditor::cleanDataBuffer(){
	for (unsigned int i=0;i<_HEX_BUFFER_LENGTH_;i++){
		this->dataBuffer[i]=0;
	}

	refreshTable();
}

void  hexEditor::setEditable(bool state){
	int index=0;
	for (int i=0;i<filas;i++){
		for (int j=0;j<columnas;j++){
				dataEditors[index++]->setEnabled(state);
		}
	}
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="hexEditor" componentName=""
                 parentClasses="public Component" constructorParams="" variableInitialisers=""
                 snapPixels="4" snapActive="1" snapShown="1" overlayOpacity="0.330000013"
                 fixedSize="1" initialWidth="300" initialHeight="240">
  <BACKGROUND backgroundColour="ffffffff"/>
  <TEXTBUTTON name="start" id="b7e3a79b99cbcf67" memberName="startButton" virtualName=""
              explicitFocusOrder="0" pos="12 134 64 24" buttonText="START"
              connectedEdges="2" needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="previous" id="f210ec72a488477e" memberName="previousButton"
              virtualName="" explicitFocusOrder="0" pos="76 134 72 24" buttonText="PREVIOUS"
              connectedEdges="3" needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="next" id="25d9fd858ef6a92b" memberName="nextButton" virtualName=""
              explicitFocusOrder="0" pos="148 134 72 24" buttonText="NEXT"
              connectedEdges="3" needsCallback="1" radioGroupId="0"/>
  <TEXTBUTTON name="end" id="8f44826484243ea8" memberName="endButton" virtualName=""
              explicitFocusOrder="0" pos="220 134 66 24" buttonText="END" connectedEdges="1"
              needsCallback="1" radioGroupId="0"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif

//==============================================================================
// Binary resources - be careful not to edit any of these sections!

// JUCER_RESOURCE: resultset_first_png, 507, "../../../../Recursos/ICONOS/SET2_FATCOW/16x16/resultset_first.png"
static const unsigned char resource_hexEditor_resultset_first_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,0,16,0,0,0,16,8,6,0,0,0,31,243,255,97,0,0,0,25,116,69,88,116,83,111,102,116,119,
97,114,101,0,65,100,111,98,101,32,73,109,97,103,101,82,101,97,100,121,113,201,101,60,0,0,1,157,73,68,65,84,120,218,164,83,75,75,2,81,20,62,119,198,153,59,99,69,91,91,182,17,130,94,144,75,161,48,52,18,
212,150,109,123,236,130,214,69,145,4,213,166,232,7,244,35,162,7,154,154,90,4,181,74,152,63,32,181,107,159,162,54,206,189,183,227,51,31,227,38,15,92,230,114,206,249,190,249,206,119,239,37,66,8,24,38,36,
24,50,28,173,141,255,44,117,99,49,17,169,39,101,233,54,125,16,88,179,3,44,159,36,133,36,145,251,212,190,63,220,165,160,138,224,139,45,47,92,110,123,129,49,30,177,3,47,30,39,196,134,207,13,140,139,80,223,
8,130,115,40,86,24,236,221,229,129,16,59,240,131,216,13,207,194,183,201,177,87,244,123,80,195,148,24,7,167,166,244,25,179,132,224,157,208,52,156,167,243,96,90,124,128,137,200,80,54,1,84,69,233,1,39,196,
102,96,202,186,122,251,130,81,157,66,21,241,157,10,29,157,205,101,38,128,210,26,65,67,162,15,13,91,247,78,150,51,31,37,125,68,215,234,185,31,70,236,79,129,52,139,20,21,116,94,141,138,197,64,81,85,208,
120,3,216,51,65,183,7,21,108,82,21,185,173,32,123,184,226,185,126,253,212,231,92,78,208,168,134,139,130,9,100,240,69,170,10,9,168,170,64,135,128,220,115,116,213,115,157,49,96,198,69,129,106,20,44,132,
144,65,4,38,18,244,154,88,35,121,138,6,61,177,172,1,238,137,113,224,221,182,253,17,72,104,45,119,80,208,117,29,93,38,182,36,241,248,11,200,56,138,237,41,96,178,240,24,75,143,145,134,31,5,155,139,152,203,
30,5,61,242,105,242,29,235,197,54,174,245,26,241,175,243,248,145,155,121,134,203,24,240,126,22,106,117,196,25,93,4,255,141,95,1,6,0,117,147,148,81,54,130,182,147,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* hexEditor::resultset_first_png = (const char*) resource_hexEditor_resultset_first_png;
const int hexEditor::resultset_first_pngSize = 507;

// JUCER_RESOURCE: resultset_last_png, 506, "../../../../Recursos/ICONOS/SET2_FATCOW/16x16/resultset_last.png"
static const unsigned char resource_hexEditor_resultset_last_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,0,16,0,0,0,16,8,6,0,0,0,31,243,255,97,0,0,0,25,116,69,88,116,83,111,102,116,119,
97,114,101,0,65,100,111,98,101,32,73,109,97,103,101,82,101,97,100,121,113,201,101,60,0,0,1,156,73,68,65,84,120,218,164,83,77,75,195,64,20,156,77,27,55,169,138,120,211,171,7,69,16,21,241,168,180,136,86,
16,106,189,234,81,189,9,158,69,4,45,168,23,197,31,224,143,16,45,218,90,250,161,32,122,19,250,7,138,222,60,122,104,105,106,155,221,117,19,155,210,52,233,197,14,44,89,242,118,230,205,123,111,151,8,33,208,
11,20,244,136,160,179,137,158,103,147,76,136,88,225,104,149,248,29,92,62,203,220,154,76,196,109,82,64,185,203,30,174,108,184,28,152,140,199,18,155,115,88,60,73,251,214,212,144,228,203,157,5,92,237,46,
128,49,30,247,148,192,37,237,187,106,98,127,125,26,225,132,87,68,112,142,74,141,225,32,89,2,33,190,61,16,48,26,2,23,185,18,246,98,83,136,116,136,88,156,42,227,8,105,170,171,113,173,189,165,90,103,4,131,
186,134,235,183,47,108,71,39,205,72,226,81,180,43,24,117,160,79,85,253,167,96,101,48,152,64,72,167,246,202,127,84,131,91,225,49,99,233,52,211,18,177,226,148,170,182,91,207,20,44,212,185,2,93,30,32,210,
142,218,167,162,102,54,92,37,252,72,135,84,58,104,191,58,174,123,80,23,10,52,74,229,210,48,51,18,194,205,235,167,46,199,58,239,8,212,56,145,37,4,186,57,16,182,0,213,40,38,134,21,220,228,139,120,62,94,
179,200,239,173,81,90,113,233,76,116,235,129,169,168,24,31,29,194,125,161,136,167,14,178,227,176,123,19,137,130,0,237,71,42,245,226,201,108,31,148,125,225,65,10,93,215,237,30,121,74,144,74,149,124,58,
55,224,151,185,57,230,114,246,33,55,72,254,220,150,91,255,157,215,40,85,103,229,39,224,71,110,194,137,91,144,207,70,20,93,2,255,197,175,0,3,0,143,51,152,202,20,218,25,132,0,0,0,0,73,69,78,68,174,66,96,
130,0,0};

const char* hexEditor::resultset_last_png = (const char*) resource_hexEditor_resultset_last_png;
const int hexEditor::resultset_last_pngSize = 506;

// JUCER_RESOURCE: resultset_next_png, 380, "../../../../Recursos/ICONOS/SET2_FATCOW/16x16/resultset_next.png"
static const unsigned char resource_hexEditor_resultset_next_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,0,16,0,0,0,16,8,6,0,0,0,31,243,255,97,0,0,0,25,116,69,88,116,83,111,102,116,119,
97,114,101,0,65,100,111,98,101,32,73,109,97,103,101,82,101,97,100,121,113,201,101,60,0,0,1,30,73,68,65,84,120,218,98,252,255,255,63,3,37,128,137,129,66,128,97,128,91,219,238,77,206,173,187,254,51,50,50,
50,160,99,162,12,248,243,247,159,111,99,164,17,131,109,195,246,255,100,185,224,31,80,219,251,111,127,24,242,252,244,24,236,27,9,27,130,37,12,254,51,124,255,253,159,161,123,207,93,134,108,95,29,6,7,2,134,
96,24,0,242,234,175,191,140,12,188,156,28,12,179,142,61,103,72,114,211,252,227,208,184,3,167,33,44,24,6,0,241,247,191,255,25,184,56,217,193,134,237,189,255,141,37,202,94,233,59,83,203,206,255,80,105,252,
6,128,192,175,127,76,12,156,236,172,224,144,103,101,99,101,248,241,231,55,105,233,224,215,127,38,6,14,118,118,32,230,96,208,151,224,98,88,119,244,1,231,190,26,119,19,162,188,0,10,68,144,1,236,28,236,12,
234,130,76,12,235,246,94,96,56,80,239,5,210,124,150,184,64,4,165,5,38,86,6,53,73,126,134,45,251,46,48,236,199,163,25,71,44,48,49,48,179,115,51,108,219,118,24,175,205,56,13,0,10,124,217,187,125,15,65,155,
225,22,162,231,70,96,200,27,0,41,102,108,154,177,229,92,70,74,179,51,64,128,1,0,152,240,96,215,84,39,183,116,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* hexEditor::resultset_next_png = (const char*) resource_hexEditor_resultset_next_png;
const int hexEditor::resultset_next_pngSize = 380;

// JUCER_RESOURCE: resultset_previous_png, 381, "../../../../Recursos/ICONOS/SET2_FATCOW/16x16/resultset_previous.png"
static const unsigned char resource_hexEditor_resultset_previous_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,0,16,0,0,0,16,8,6,0,0,0,31,243,255,97,0,0,0,25,116,69,88,116,83,111,102,116,
119,97,114,101,0,65,100,111,98,101,32,73,109,97,103,101,82,101,97,100,121,113,201,101,60,0,0,1,31,73,68,65,84,120,218,98,252,255,255,63,3,37,128,137,129,66,128,97,0,35,35,35,6,118,110,221,245,223,173,
109,247,38,178,92,96,219,176,253,127,99,164,17,195,159,191,255,124,177,201,179,224,211,108,223,184,253,127,142,175,30,195,251,111,127,24,254,253,39,49,12,28,128,154,179,125,117,24,186,247,220,101,248,
254,27,164,251,63,241,6,56,52,238,248,159,228,166,249,103,214,177,231,12,188,156,28,12,191,254,130,194,2,187,69,24,94,112,106,217,249,63,194,70,241,251,222,251,223,56,185,56,217,25,64,177,252,253,239,
127,6,28,250,177,135,193,143,63,127,25,88,217,216,24,56,255,49,50,128,210,201,175,127,76,196,71,227,190,26,119,147,117,71,31,112,234,75,112,49,112,176,115,0,49,59,195,175,255,76,36,37,164,179,7,234,61,
77,214,237,189,192,160,43,193,206,192,206,1,51,224,63,73,177,112,118,127,189,151,201,150,125,23,24,212,36,249,25,254,48,177,226,12,3,124,9,9,232,18,47,147,109,219,14,51,48,179,115,3,99,129,137,129,228,
132,4,115,9,51,243,142,51,64,237,95,176,41,96,68,207,141,140,216,35,220,24,136,255,2,213,94,32,104,0,169,0,32,192,0,162,241,103,107,195,247,249,18,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* hexEditor::resultset_previous_png = (const char*) resource_hexEditor_resultset_previous_png;
const int hexEditor::resultset_previous_pngSize = 381;
